/*
 * htmlbuffer.h
 * htmllite
 *
 * by Doug Wolfe
 * doug@wolfescience.com 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc.,  59 Temple Place - Suite 330, Cambridge, MA 02139, USA.
 *
 */

#include <gtk/gtk.h>

//for xml
#include <libxml/xmlreader.h>
#include <libxml/encoding.h>
#include <libxml/xmlwriter.h>

//TODO:Convert font tags to span with style: attributes tags

GtkTextBuffer *create_buffer (GtkTextView *textview, gboolean writeable);
void on_buffer_changed (GtkTextBuffer *textbuffer, gpointer user_data);

gchar * WriteXHTML_as_Markup (GtkTextBuffer *textbuffer, const char *file);
gchar * WriteXHTML	(GtkTextBuffer *textbuffer, const char *file);
void set_XHTML (GtkTextBuffer *textbuffer, gchar *text);

void processHTMLNode (GtkTextBuffer *textbuffer, xmlTextReaderPtr reader);
void import_XHTML (GtkTextBuffer *textbuffer, gchar * xml, gboolean markup);
int strrepl(char *InputString,char *StringToFind, char *StringToReplace,char *output);

void add_undo (GtkTextBuffer *textbuffer);
void add_redo (GtkTextBuffer *textbuffer);
void Undo (GtkTextBuffer *textbuffer);
void Redo (GtkTextBuffer *textbuffer);

void toggle_Bold (GtkTextBuffer *textbuffer, gboolean enable);
void toggle_Italic (GtkTextBuffer *textbuffer, gboolean enable);
void toggle_Underline (GtkTextBuffer *textbuffer, gboolean enable);
void toggle_Strikethrough (GtkTextBuffer *textbuffer, gboolean enable);
void toggle_Superscript (GtkTextBuffer *textbuffer, gboolean enable);
void toggle_Subscript (GtkTextBuffer *textbuffer, gboolean enable);
void adjust_fontsize_absolute(GtkTextBuffer *textbuffer, gchar * fontsize);
void htmllite_change_fontfamily (GtkTextBuffer * textbuffer, GtkWidget * widget, gchar * fontfamily);

void open_color_dialog (GtkTextBuffer *textbuffer);
void open_symbol_dialog (GtkTextBuffer *textbuffer);
void on_button_Symbol_activate (GtkButton *button, gpointer user_data);
void on_button_Symbol_clicked (GtkButton *button, gpointer user_data);
